Loading...
Searching...
No Matches
seqan3::arithmetic_range_validator< option_value_t > Class Template Reference
Argument Parser

A validator that checks whether a number is inside a given range. More...

`#include <seqan3/argument_parser/validators.hpp>`

Inheritance diagram for seqan3::arithmetic_range_validator< option_value_t >:
[legend]

## Public Types

using | option_value_type = option_value_t
| The type of value that this validator invoked upon.

## Public Member Functions

| arithmetic_range_validator (option_value_type const min_, option_value_type const max_)
| The constructor.
std::string | get_help_page_message () const
| Returns a message that can be appended to the (positional) options help page info.
void | operator() (option_value_type const &cmp) const
| Tests whether cmp lies inside [min, max].
template<std::ranges::forward_range range_type> requires arithmetic<std::ranges::range_value_t<range_type>>
void | operator() (range_type const &range) const
| Tests whether every element in `range` lies inside [min, max].

## Additional Inherited Members

Related Symbols inherited from validator
using | option_value_type
| The type of value on which the validator is called on.
void | operator() (option_value_type const &cmp) const
| Validates the value 'cmp' and throws a seqan3::validation_error on failure.

## Detailed Description

template<arithmetic option_value_t>
class seqan3::arithmetic_range_validator< option_value_t >

A validator that checks whether a number is inside a given range.

Template Parameters

  option_value_t | The value type of the range; must model seqan3::arithmetic .

On construction, the validator must receive a maximum and a minimum number. The class than acts as a functor, that throws a seqan3::validation_error exception whenever a given value does not lie inside the given min/max range.

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/argument_parser/all.hpp>
#include <seqan3/core/debug_stream.hpp>
int main(int argc, char const ** argv)
{
seqan3::argument_parser myparser{"Test", argc, argv}; // initialize
int myint;
seqan3::arithmetic_range_validator my_validator{2, 10};
myparser.add_option(myint, 'i', "integer", "Give me a number.", seqan3::option_spec::standard, my_validator);
// an exception will be thrown if the user specifies an integer
// that is not in range [2,10] (e.g. "./test_app -i 15")
try
{
myparser.parse();
}
catch (seqan3::argument_parser_error const & ext) // the user did something wrong
{
std::cerr << "[PARSER ERROR] " << ext.what() << "\n"; // customize your error message
return -1;
}
seqan3::debug_stream << "integer given by user passed validation: " << myint << "\n";
return 0;
}
all.hpp
Meta-header for the Argument Parser module .
std::cerr
seqan3::argument_parser_error
Argument parser exception that is thrown whenever there is an error while parsing the command line ar...
Definition exceptions.hpp:39
seqan3::argument_parser
The SeqAn command line parser.
Definition argument_parser.hpp:147
seqan3::argument_parser::add_option
void add_option(option_type &value, char const short_id, std::string const &long_id, std::string const &desc, option_spec const spec=option_spec::standard, validator_type option_validator=validator_type{})
Adds an option to the seqan3::argument_parser.
Definition argument_parser.hpp:238
seqan3::argument_parser::parse
void parse()
Initiates the actual command line parsing.
Definition argument_parser.hpp:404
seqan3::arithmetic_range_validator
A validator that checks whether a number is inside a given range.
Definition validators.hpp:124
debug_stream.hpp
Provides seqan3::debug_stream and related types.
seqan3::standard
@ standard
The default were no checking or special displaying is happening.
Definition auxiliary.hpp:250
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
std::runtime_error::what
T what(T... args)

Remarks
  For a complete overview, take a look at Argument Parser

## Constructor & Destructor Documentation

## arithmetic_range_validator()

template<arithmetic option_value_t>

seqan3::arithmetic_range_validator< option_value_t >::arithmetic_range_validator | ( | option_value_type const | min_,
|  | option_value_type const | max_ )

inline

The constructor.

Parameters

  [in] | min_ | Minimum set for the range to test.
  [in] | max_ | Maximum set for the range to test.

## Member Function Documentation

## get_help_page_message()

template<arithmetic option_value_t>

std::string seqan3::arithmetic_range_validator< option_value_t >::get_help_page_message | ( |  | ) | const

inline

Returns a message that can be appended to the (positional) options help page info.

Implements validator.

## operator()() [1/2]

template<arithmetic option_value_t>

void seqan3::arithmetic_range_validator< option_value_t >::operator() | ( | option_value_type const & | cmp | ) | const

inline

Tests whether cmp lies inside [min, max].

Parameters

  cmp | The input value to check.

Exceptions

  seqan3::validation_error |

## operator()() [2/2]

template<arithmetic option_value_t>
template<std::ranges::forward_range range_type>
requires arithmetic<std::ranges::range_value_t<range_type>>

void seqan3::arithmetic_range_validator< option_value_t >::operator() | ( | range_type const & | range | ) | const

inline

Tests whether every element in `range` lies inside [min, max].

Template Parameters

  range_type | The type of range to check; must model std::ranges::forward_range. The value type must model seqan3::arithmetic.

Parameters

  range | The input range to iterate over and check every element.

Exceptions

  seqan3::validation_error |

The documentation for this class was generated from the following file:

- validators.hpp

Hide me